unit ChangePwdu;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TfChangePassword = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    edpwd1: TEdit;
    edPWD2: TEdit;
    Label3: TLabel;
    btnOK: TButton;
    btnCancel: TButton;
    procedure btnOKClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure edpwd1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fChangePassword: TfChangePassword;

implementation
uses dmu;
{$R *.dfm}

procedure TfChangePassword.btnOKClick(Sender: TObject);
begin
  if edPwd1.Text = edPwd2.Text then
    begin
    dm.UnixCrypt1.Salt:=copy(dm.Uname,1,2);
    dm.UnixCrypt1.Key:=edPwd1.Text;
    //save encrypted new password
    with dm.pFIBQ do
      begin
      close;
      SQL.Clear;
      SQL.Add('update USERS set PWORD = :PWD where USERNAME = :USER_NAME');
      ParamByName('PWD').AsString:=dm.UnixCrypt1.Result;
      ParamByName('USER_NAME').AsString := dm.Uname;
      dm.pFIBTrans.Active:=true;
      ExecQuery;    
      with Database.DefaultTransaction do
          if InTransaction then 
            Commit;
      Close;  
      end;
    ModalResult:=mrOK;   
    end
    else
    ModalResult:=mrCancel;
end;

procedure TfChangePassword.btnCancelClick(Sender: TObject);
begin
  ModalResult:=mrCancel;
end;

//check for length not less than 6 chars

procedure TfChangePassword.edpwd1KeyPress(Sender: TObject; var Key: Char);
begin
  btnOK.Enabled:=(Length(edpwd1.Text) > 5) and (Length(edpwd2.Text) > 5);
end;

end.
